unit KalMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, StdCtrls, Spin, Grids, ExtCtrls, SRCal, Buttons;

type
  TMainForm = class(TForm)
    CBAstroDaten: TCheckBox;
    ComboGermanState: TComboBox;
    ComboStartTag: TComboBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    LblDatum: TLabel;
    LblFeiertag: TLabel;
    LblSternzeichen: TLabel;
    LblTagImJahr: TLabel;
    LblWocheImJahr: TLabel;
    LblSunRise: TLabel;
    LblSunSet: TLabel;
    LblSunDist: TLabel;
    LblMoonRise: TLabel;
    LblMoonSet: TLabel;
    LblMoonDist: TLabel;
    LblMoonPhase: TLabel;
    LblMonat: TLabel;
    LblJahr: TLabel;
    PanelAstroDaten: TPanel;
    SpinMonat: TSpinButton;
    SpinJahr: TSpinButton;
    CBDeleteMarks: TCheckBox;
    Label5: TLabel;
    CBShowMarks: TCheckBox;
    CBShowHolidays: TCheckBox;
    LblMoonTransit: TLabel;
    LblSunTransit: TLabel;
    Label43: TLabel;
    ComboDrawStyle: TComboBox;
    CBGridLines: TCheckBox;
    CBFrameSelection: TCheckBox;
    CBSatAsSun: TCheckBox;
    Kalender: TSRCalendar;
    LblSeason: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure KalenderChange(Sender: TObject);
    procedure SpinMonatDownClick(Sender: TObject);
    procedure SpinMonatUpClick(Sender: TObject);
    procedure SpinJahrDownClick(Sender: TObject);
    procedure SpinJahrUpClick(Sender: TObject);
    procedure ComboGermanStateChange(Sender: TObject);
    procedure CBAstroDatenClick(Sender: TObject);
    procedure ComboStartTagChange(Sender: TObject);
    procedure KalenderDblClick(Sender: TObject);
    procedure CBDeleteMarksClick(Sender: TObject);
    procedure CBShowHolidaysClick(Sender: TObject);
    procedure CBShowMarksClick(Sender: TObject);
    procedure ComboDrawStyleChange(Sender: TObject);
    procedure CBGridLinesClick(Sender: TObject);
    procedure CBFrameSelectionClick(Sender: TObject);
    procedure KalenderMonthChange(Sender: TObject);
    procedure KalenderYearChange(Sender: TObject);
    procedure CBSatAsSunClick(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  MainForm: TMainForm;

implementation

{$R *.DFM}

procedure TMainForm.SpinMonatDownClick(Sender: TObject);
begin
  Kalender.PrevMonth;
end;

procedure TMainForm.SpinMonatUpClick(Sender: TObject);
begin
  Kalender.NextMonth;
end;

procedure TMainForm.SpinJahrDownClick(Sender: TObject);
begin
  Kalender.PrevYear;
end;

procedure TMainForm.SpinJahrUpClick(Sender: TObject);
begin
  Kalender.NextYear;
end;

procedure TMainForm.ComboGermanStateChange(Sender: TObject);
begin
  if ComboGermanState.ItemIndex>=0 then
    Kalender.GermanState:=TGermanState(ComboGermanState.ItemIndex);
end;

procedure TMainForm.ComboStartTagChange(Sender: TObject);
begin
  Kalender.StartOfWeek:=TDayOfWeek(ComboStartTag.ItemIndex);
end;

procedure TMainForm.ComboDrawStyleChange(Sender: TObject);
begin
  Kalender.DrawStyle:=TCalendarDrawStyle(ComboDrawStyle.ItemIndex);
end;

procedure TMainForm.CBSatAsSunClick(Sender: TObject);
begin
  Kalender.SaturdayAsSunday:=CBSatAsSun.Checked;
end;

procedure TMainForm.CBShowHolidaysClick(Sender: TObject);
begin
  if CBShowHolidays.Checked then
    Kalender.CalendarOptions:=Kalender.CalendarOptions+[coCalcHolidays]
  else
    Kalender.CalendarOptions:=Kalender.CalendarOptions-[coCalcHolidays];
  if Kalender.HolidayNr<0 then
    LblFeiertag.Font.Color:=clNavy
  else
    LblFeiertag.Font.Color:=clRed;
  LblFeiertag.Caption:=Kalender.Holiday;
end;

procedure TMainForm.CBGridLinesClick(Sender: TObject);
begin
  if CBGridLines.Checked then
    Kalender.CalendarOptions:=Kalender.CalendarOptions+[coGridLines]
  else
    Kalender.CalendarOptions:=Kalender.CalendarOptions-[coGridLines];
end;

procedure TMainForm.CBFrameSelectionClick(Sender: TObject);
begin
  if CBFrameSelection.Checked then
    Kalender.CalendarOptions:=Kalender.CalendarOptions+[coFrameSelection]
  else
    Kalender.CalendarOptions:=Kalender.CalendarOptions-[coFrameSelection];
end;

procedure TMainForm.CBShowMarksClick(Sender: TObject);
begin
  if CBShowMarks.Checked then
    Kalender.CalendarOptions:=Kalender.CalendarOptions+[coShowMarks]
  else
    Kalender.CalendarOptions:=Kalender.CalendarOptions-[coShowMarks];
end;

procedure TMainForm.CBDeleteMarksClick(Sender: TObject);
begin
  if CBDeleteMarks.Checked then
    Kalender.CalendarOptions:=Kalender.CalendarOptions+[coAutoDeleteMarks]
  else
    Kalender.CalendarOptions:=Kalender.CalendarOptions-[coAutoDeleteMarks];
end;

procedure TMainForm.CBAstroDatenClick(Sender: TObject);
begin
  if CBAstroDaten.Checked then
    Kalender.CalendarOptions:=Kalender.CalendarOptions+[coCalcAstroData]
  else
    Kalender.CalendarOptions:=Kalender.CalendarOptions-[coCalcAstroData];
  PanelAstroDaten.Visible:=CBAstroDaten.Checked;
end;

procedure TMainForm.KalenderChange(Sender: TObject);
begin
  LblDatum.Caption:=FormatDateTime('dddd, dd. mmmm yyyy',Kalender.Date);
  LblTagImJahr.Caption:=IntToStr(Kalender.DayOfYear)+'. Tag im Jahr';
  LblWocheImJahr.Caption:=IntToStr(Kalender.WeekOfYear)+'. Woche im Jahr';
  if Kalender.HolidayNr<0 then
    LblFeiertag.Font.Color:=clNavy
  else
    LblFeiertag.Font.Color:=clRed;
  LblFeiertag.Caption:=Kalender.Holiday;
  LblSeason.Caption:=Jahreszeit[ord(Kalender.Season)];
  LblSternzeichen.Caption:='Sternzeichen: '+Sternzeichen[ord(Kalender.ZodiacSign)];
  LblMoonRise.Caption:='Mondaufgang: '+TimeToStr(Kalender.MoonRise)+' h';
  LblMoonTransit.Caption:='Mondhchststand: '+TimeToStr(Kalender.MoonTransit)+' h';
  LblMoonSet.Caption:='Monduntergang: '+TimeToStr(Kalender.MoonSet)+' h';
  LblMoonDist.Caption:='Entfernung zum Mond: '+FloatToStrF(Kalender.MoonDistance,ffNumber,8,0)+' km';
  LblMoonPhase.Caption:=MondPhase[ord(Kalender.MoonPhase)];
  case Kalender.MoonPhase of
    mpNewMoon      : LblMoonPhase.Font.Color:=clBlue;
    mpFullMoon     : LblMoonPhase.Font.Color:=clRed;
    mpLastQuarter  : LblMoonPhase.Font.Color:=clNavy;
    mpFirstQuarter : LblMoonPhase.Font.Color:=clMaroon;
  end;
  LblSunRise.Caption:='Sonnenaufgang: '+TimeToStr(Kalender.SunRise)+' h';
  LblSunTransit.Caption:='Sonnenhchststand: '+TimeToStr(Kalender.SunTransit)+' h';
  LblSunSet.Caption:='Sonnenuntergang: '+TimeToStr(Kalender.SunSet)+' h';
  LblSunDist.Caption:='Entfernung zur Sonne: '+FloatToStrF(Kalender.SunDistance/1000000,ffNumber,8,2)+' mio km';
end;

procedure TMainForm.KalenderDblClick(Sender: TObject);
begin
  Kalender.Marked[Kalender.Day]:=not Kalender.Marked[Kalender.Day];
end;

procedure TMainForm.KalenderMonthChange(Sender: TObject);
begin
  LblMonat.Caption:=LongMonthNames[Kalender.Month];
end;

procedure TMainForm.KalenderYearChange(Sender: TObject);
begin
  LblJahr.Caption:=IntToStr(Kalender.Year);
end;

procedure TMainForm.FormCreate(Sender: TObject);
var i : byte;
begin
  ComboGermanState.ItemIndex:=ord(Kalender.GermanState);
  for i:=1 to 7 do
    ComboStartTag.Items.Add(LongDayNames[i]);
  ComboStartTag.ItemIndex:=ord(Kalender.StartOfWeek);
  ComboDrawStyle.ItemIndex:=ord(Kalender.DrawStyle);
  Kalender.Date:=Date;
  KalenderChange(nil);
  KalenderMonthChange(nil);
  KalenderYearChange(nil);
end;

end.
